; ==================================================================================================
; CHUNKS.INC - Level chunks. These are linked together to generate the random levels.
; ==================================================================================================

;Addressing table:

Start_Chunks:
.dw Start_With_Blob_Row
.dw Start_With_Turret
.dw Start_Blobs_Dome
.dw Start_Chain_Mini_Turrets
EO_S:

Mid_Chunks:
.dw Mid_Two_Round_White
.dw Mid_Turret_Harbour
.dw Mid_Loads_Of_Turrets
.dw Mid_Holes
EO_M:

End_Chunks:
.dw End_With_Turret
.dw End_Jagged
.dw End_Prongs
.dw End_Harbour
EO_E:

Space_Chunks:
.dw Space_Jutting
.dw Space_Turret
.dw Space_Turret_2
.dw Space_Bridge
.dw Space_Scaffold
EO_Sp:

; ==================================================================================================
; Start chunks - these precede a land area.
; ==================================================================================================

Start_With_Blob_Row:
.dw 12*5
.db $01,$08,$0E,$0E,$08,$04,$00,$00,$00,$00,$00,$01
.db $0D,$0E,$0E,$0E,$0E,$0C,$08,$08,$08,$08,$08,$0D
.db $2C,$2C,$0E,$0E,$2C,$2C,$09,$2C,$09,$09,$16,$17
.db $2C,$2C,$2C,$2C,$2C,$2C,$2C,$2C,$2C,$09,$14,$15
.db $2C,$19,$2C,$19,$2C,$19,$2C,$19,$2C,$19,$09,$2C

Start_With_Turret:
.dw 12*7
.db $04,$00,$01,$04,$00,$01,$04,$00,$01,$04,$00,$01
.db $0C,$08,$0D,$0C,$08,$0D,$0C,$08,$0D,$0C,$08,$0D
.db $09,$09,$09,$09,$11,$13,$13,$0F,$09,$09,$09,$09
.db $09,$09,$11,$13,$12,$2C,$2C,$10,$13,$0F,$09,$09
.db $09,$11,$12,$2C,$09,$21,$22,$0F,$2C,$10,$0F,$09
.db $13,$12,$09,$19,$09,$1F,$20,$13,$13,$13,$13,$13
.db $09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09

Start_Blobs_Dome:
.dw 12*6
.db $00,$00,$00,$00,$00,$01,$04,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$05,$0C,$04,$00,$00,$00,$00
.db $00,$01,$08,$04,$01,$0D,$19,$07,$00,$00,$00,$00
.db $00,$05,$19,$0C,$0D,$09,$09,$0C,$08,$04,$00,$00
.db $00,$05,$09,$09,$09,$19,$09,$16,$17,$0C,$08,$04
.db $08,$0D,$09,$09,$19,$09,$09,$14,$15,$09,$09,$0C

Start_Chain_Mini_Turrets:
.dw 12*5
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
.db $04,$00,$00,$00,$01,$04,$00,$00,$00,$00,$00,$05
.db $07,$00,$00,$00,$05,$07,$00,$01,$08,$04,$00,$05
.db $07,$01,$04,$00,$05,$0C,$08,$0D,$1C,$0C,$08,$0D
.db $0C,$0D,$0C,$08,$0D,$1C,$13,$13,$13,$13,$1C,$09


; ==================================================================================================
; Middle chunks - these make up a land area.
; ==================================================================================================


Mid_Two_Round_White:
.dw 12*6
.db $09,$09,$09,$09,$09,$16,$17,$09,$0E,$0E,$0E,$0E
.db $0E,$11,$13,$0F,$09,$14,$15,$09,$09,$0E,$0E,$0E
.db $0E,$0E,$13,$13,$13,$13,$13,$13,$0F,$09,$0E,$0E
.db $0E,$0E,$0E,$12,$09,$16,$17,$09,$10,$0F,$09,$0E
.db $0E,$0E,$0E,$0E,$09,$14,$15,$09,$09,$1C,$13,$13
.db $09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09

Mid_Turret_Harbour:
.dw 12*8
.db $2C,$09,$2C,$09,$2C,$09,$2C,$2C,$2C,$2C,$09,$09
.db $2C,$09,$0B,$06,$06,$06,$06,$0A,$09,$09,$2C,$2C
.db $09,$1C,$07,$00,$00,$00,$00,$05,$2C,$24,$27,$27
.db $06,$26,$03,$00,$21,$22,$00,$05,$2C,$26,$18,$18
.db $00,$26,$00,$00,$1F,$20,$27,$27,$27,$24,$27,$27
.db $08,$26,$04,$00,$00,$00,$00,$05,$09,$2C,$09,$2C
.db $09,$1C,$0C,$08,$08,$08,$08,$0D,$2C,$2C,$2C,$09
.db $2C,$2C,$2C,$09,$2C,$2C,$09,$2C,$2C,$09,$2C,$09

Mid_Loads_Of_Turrets:
.dw 12*4
.db $09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09
.db $09,$1C,$09,$1C,$09,$21,$22,$13,$13,$13,$13,$13
.db $13,$13,$13,$13,$13,$1F,$20,$12,$09,$09,$1C,$09
.db $09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09

Mid_Domes:
.dw 12*6
.db $09,$2C,$2C,$09,$2C,$2C,$09,$1B,$1B,$09,$2C,$09
.db $2C,$1B,$1B,$1B,$1B,$09,$1B,$1A,$1A,$1B,$1B,$1B
.db $1B,$1A,$1A,$1A,$1B,$1B,$1A,$1A,$1A,$1A,$16,$17
.db $1A,$16,$17,$1A,$1A,$1A,$1A,$1B,$1B,$1A,$14,$15
.db $1A,$14,$15,$1A,$1A,$1B,$2C,$09,$2C,$1B,$1A,$1A
.db $1B,$1B,$1B,$1B,$1B,$2C,$09,$2C,$2C,$09,$1B,$1B

Mid_Holes:
.dw 12*5
.db $2C,$09,$09,$09,$0B,$06,$06,$0A,$09,$19,$09,$2C
.db $18,$0B,$06,$0A,$07,$00,$00,$05,$2C,$09,$09,$09
.db $09,$07,$00,$05,$0C,$08,$08,$0D,$0B,$06,$0A,$18
.db $2C,$0C,$08,$0D,$09,$2C,$09,$2C,$07,$00,$05,$09
.db $09,$09,$2C,$2C,$09,$19,$2C,$09,$0C,$08,$0D,$2C



; ==================================================================================================
; End chunks - these end up a land area.
; ==================================================================================================

End_With_Turret:
.dw 12*5
.db $06,$0A,$2C,$0E,$2C,$09,$2C,$2C,$2C,$2C,$1C,$2C
.db $00,$05,$0E,$0E,$0E,$09,$13,$13,$13,$13,$13,$13
.db $00,$02,$0A,$0E,$2C,$2C,$13,$2C,$1C,$0B,$06,$06
.db $00,$00,$02,$06,$21,$22,$13,$06,$06,$03,$00,$00
.db $00,$00,$00,$00,$1F,$20,$12,$00,$00,$00,$00,$00

End_Jagged:
.dw 12*5
.db $09,$1D,$0B,$06,$0A,$09,$1D,$09,$09,$1D,$09,$1D
.db $1D,$09,$07,$00,$05,$0B,$06,$06,$06,$0A,$1D,$09
.db $06,$0A,$07,$00,$02,$03,$00,$00,$00,$05,$0B,$03
.db $00,$05,$07,$00,$00,$00,$21,$22,$27,$05,$07,$00
.db $00,$02,$03,$00,$00,$00,$1F,$20,$27,$02,$03,$00

End_Prongs:
.dw 12*4
.db $0B,$06,$0A,$0B,$06,$0A,$0B,$06,$0A,$0B,$06,$0A
.db $03,$00,$05,$07,$00,$05,$07,$00,$05,$07,$00,$02
.db $00,$00,$02,$03,$00,$05,$07,$00,$02,$03,$00,$00
.db $00,$00,$00,$00,$00,$02,$03,$00,$00,$00,$00,$00

End_Harbour:
.dw 12*6
.db $09,$09,$09,$0B,$06,$06,$06,$06,$06,$0A,$2C,$09
.db $2C,$09,$09,$07,$00,$00,$00,$00,$01,$0D,$21,$22
.db $09,$2C,$24,$27,$27,$24,$27,$27,$27,$24,$1F,$20
.db $2C,$09,$0B,$03,$00,$26,$00,$00,$05,$2C,$2C,$2C
.db $0A,$24,$27,$27,$27,$24,$27,$27,$27,$27,$24,$0B
.db $02,$06,$03,$00,$00,$25,$00,$00,$02,$06,$06,$03

; ==================================================================================================
; Space chunks - these fill in the gaps betwixt the land chunks.
; ==================================================================================================

Space_Jutting:
.dw 12*4
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$08,$08
.db $04,$00,$00,$00,$00,$00,$00,$00,$00,$05,$19,$09
.db $0C,$08,$08,$08,$04,$00,$00,$00,$00,$02,$06,$06
.db $1D,$06,$06,$06,$03,$00,$00,$00,$00,$00,$00,$00

Space_Turret:
.dw 12*3
.db $00,$00,$00,$00,$00,$21,$22,$00,$00,$00,$00,$00
.db $27,$24,$27,$24,$27,$1F,$20,$27,$24,$27,$24,$27
.db $00,$25,$00,$25,$00,$00,$00,$00,$25,$00,$25,$00

Space_Turret_2:
.dw 12*6
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$24,$27,$27
.db $00,$19,$00,$19,$00,$00,$00,$00,$00,$26,$00,$00
.db $27,$27,$27,$27,$27,$24,$00,$00,$21,$22,$00,$00
.db $00,$19,$00,$19,$00,$00,$00,$00,$1F,$20,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$26,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$24,$27,$27

Space_Bridge:
.dw 12*6
.db $01,$08,$08,$08,$08,$08,$08,$04,$00,$00,$00,$01
.db $0D,$0E,$1B,$0E,$1A,$0E,$1B,$07,$00,$00,$01,$0D
.db $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0C,$08,$08,$0D,$19
.db $1B,$0E,$1A,$0E,$1B,$0E,$1A,$0B,$06,$06,$0A,$19
.db $0B,$06,$06,$06,$06,$06,$06,$03,$00,$00,$02,$06
.db $03,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00


Space_Scaffold:
.dw 12*7
.db $00,$00,$00,$00,$00,$24,$27,$24,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$26,$00,$26,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$24,$00,$24,$27,$24,$00,$00
.db $00,$24,$00,$00,$24,$18,$24,$25,$00,$26,$00,$00
.db $24,$18,$24,$27,$27,$24,$00,$00,$00,$24,$00,$00
.db $00,$24,$00,$00,$00,$26,$00,$00,$24,$18,$24,$00
.db $00,$25,$00,$00,$00,$25,$00,$00,$00,$24,$00,$00












